ExpiresFilter.XServletOutputStream (Apache Tomcat 10.0.27 API Documentation)

Package org.apache.catalina.filters

## Class ExpiresFilter.XServletOutputStream

- java.lang.Object
- - java.io.OutputStream
  - - jakarta.servlet.ServletOutputStream
    - - org.apache.catalina.filters.ExpiresFilter.XServletOutputStream

- All Implemented Interfaces:
    `java.io.Closeable`, `java.io.Flushable`, `java.lang.AutoCloseable`
  Enclosing class:
    ExpiresFilter

      public class ExpiresFilter.XServletOutputStream
      extends ServletOutputStream

  Wrapping extension of `ServletOutputStream` to trap the "Start Write Response Body" event.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `XServletOutputStream​(ServletOutputStream servletOutputStream, HttpServletRequest request, ExpiresFilter.XHttpServletResponse response)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `close()` |
    `void` | `flush()` |
    `boolean` | `isReady()` | TODO SERVLET 3.1
    `void` | `print​(boolean b)` | Writes a `boolean` value to the client, with no carriage return-line feed (CRLF) character at the end.
    `void` | `print​(char c)` | Writes a character to the client, with no carriage return-line feed (CRLF) at the end.
    `void` | `print​(double d)` | Writes a `double` value to the client, with no carriage return-line feed (CRLF) at the end.
    `void` | `print​(float f)` | Writes a `float` value to the client, with no carriage return-line feed (CRLF) at the end.
    `void` | `print​(int i)` | Writes an int to the client, with no carriage return-line feed (CRLF) at the end.
    `void` | `print​(long l)` | Writes a `long` value to the client, with no carriage return-line feed (CRLF) at the end.
    `void` | `print​(java.lang.String s)` | Writes a `String` to the client, without a carriage return-line feed (CRLF) character at the end.
    `void` | `println()` | Writes a carriage return-line feed (CRLF) to the client.
    `void` | `println​(boolean b)` | Writes a `boolean` value to the client, followed by a carriage return-line feed (CRLF).
    `void` | `println​(char c)` | Writes a character to the client, followed by a carriage return-line feed (CRLF).
    `void` | `println​(double d)` | Writes a `double` value to the client, followed by a carriage return-line feed (CRLF).
    `void` | `println​(float f)` | Writes a `float` value to the client, followed by a carriage return-line feed (CRLF).
    `void` | `println​(int i)` | Writes an int to the client, followed by a carriage return-line feed (CRLF) character.
    `void` | `println​(long l)` | Writes a `long` value to the client, followed by a carriage return-line feed (CRLF).
    `void` | `println​(java.lang.String s)` | Writes a `String` to the client, followed by a carriage return-line feed (CRLF).
    `void` | `setWriteListener​(WriteListener listener)` | TODO SERVLET 3.1
    `void` | `write​(byte[] b)` |
    `void` | `write​(byte[] b, int off, int len)` |
    `void` | `write​(int b)` |

    - ### Methods inherited from class java.io.OutputStream

      `nullOutputStream`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### XServletOutputStream

          public XServletOutputStream​(ServletOutputStream servletOutputStream,
                                      HttpServletRequest request,
                                      ExpiresFilter.XHttpServletResponse response)

  - ### Method Detail

    - #### close

          public void close()
                     throws java.io.IOException

      Specified by:
        `close` in interface `java.lang.AutoCloseable`
      Specified by:
        `close` in interface `java.io.Closeable`
      Overrides:
        `close` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### flush

          public void flush()
                     throws java.io.IOException

      Specified by:
        `flush` in interface `java.io.Flushable`
      Overrides:
        `flush` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### print

          public void print​(boolean b)
                     throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes a `boolean` value to the client, with no carriage return-line feed (CRLF) character at the end.
      Overrides:
        `print` in class `ServletOutputStream`
      Parameters:
        `b` - the `boolean` value to send to the client
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### print

          public void print​(char c)
                     throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes a character to the client, with no carriage return-line feed (CRLF) at the end.
      Overrides:
        `print` in class `ServletOutputStream`
      Parameters:
        `c` - the character to send to the client
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### print

          public void print​(double d)
                     throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes a `double` value to the client, with no carriage return-line feed (CRLF) at the end.
      Overrides:
        `print` in class `ServletOutputStream`
      Parameters:
        `d` - the `double` value to send to the client
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### print

          public void print​(float f)
                     throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes a `float` value to the client, with no carriage return-line feed (CRLF) at the end.
      Overrides:
        `print` in class `ServletOutputStream`
      Parameters:
        `f` - the `float` value to send to the client
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### print

          public void print​(int i)
                     throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes an int to the client, with no carriage return-line feed (CRLF) at the end.
      Overrides:
        `print` in class `ServletOutputStream`
      Parameters:
        `i` - the int to send to the client
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### print

          public void print​(long l)
                     throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes a `long` value to the client, with no carriage return-line feed (CRLF) at the end.
      Overrides:
        `print` in class `ServletOutputStream`
      Parameters:
        `l` - the `long` value to send to the client
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### print

          public void print​(java.lang.String s)
                     throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes a `String` to the client, without a carriage return-line feed (CRLF) character at the end.
      Overrides:
        `print` in class `ServletOutputStream`
      Parameters:
        `s` - the `String` to send to the client
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### println

          public void println()
                       throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes a carriage return-line feed (CRLF) to the client.
      Overrides:
        `println` in class `ServletOutputStream`
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### println

          public void println​(boolean b)
                       throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes a `boolean` value to the client, followed by a carriage return-line feed (CRLF).
      Overrides:
        `println` in class `ServletOutputStream`
      Parameters:
        `b` - the `boolean` value to write to the client
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### println

          public void println​(char c)
                       throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes a character to the client, followed by a carriage return-line feed (CRLF).
      Overrides:
        `println` in class `ServletOutputStream`
      Parameters:
        `c` - the character to write to the client
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### println

          public void println​(double d)
                       throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes a `double` value to the client, followed by a carriage return-line feed (CRLF).
      Overrides:
        `println` in class `ServletOutputStream`
      Parameters:
        `d` - the `double` value to write to the client
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### println

          public void println​(float f)
                       throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes a `float` value to the client, followed by a carriage return-line feed (CRLF).
      Overrides:
        `println` in class `ServletOutputStream`
      Parameters:
        `f` - the `float` value to write to the client
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### println

          public void println​(int i)
                       throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes an int to the client, followed by a carriage return-line feed (CRLF) character.
      Overrides:
        `println` in class `ServletOutputStream`
      Parameters:
        `i` - the int to write to the client
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### println

          public void println​(long l)
                       throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes a `long` value to the client, followed by a carriage return-line feed (CRLF).
      Overrides:
        `println` in class `ServletOutputStream`
      Parameters:
        `l` - the `long` value to write to the client
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### println

          public void println​(java.lang.String s)
                       throws java.io.IOException

      Description copied from class: `jakarta.servlet.ServletOutputStream`
      Writes a `String` to the client, followed by a carriage return-line feed (CRLF).
      Overrides:
        `println` in class `ServletOutputStream`
      Parameters:
        `s` - the `String` to write to the client
      Throws:
        `java.io.IOException` - if an input or output exception occurred

    - #### write

          public void write​(byte[] b)
                     throws java.io.IOException

      Overrides:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### write

          public void write​(byte[] b,
                            int off,
                            int len)
                     throws java.io.IOException

      Overrides:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### write

          public void write​(int b)
                     throws java.io.IOException

      Specified by:
        `write` in class `java.io.OutputStream`
      Throws:
        `java.io.IOException`

    - #### isReady

          public boolean isReady()

      TODO SERVLET 3.1
      Specified by:
        `isReady` in class `ServletOutputStream`
      Returns:
        `true` if data can be written, else `false`

    - #### setWriteListener

          public void setWriteListener​(WriteListener listener)

      TODO SERVLET 3.1
      Specified by:
        `setWriteListener` in class `ServletOutputStream`
      Parameters:
        `listener` - The non-blocking IO write listener